      program isnasexe
c=======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-94
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c***********************************************************************
c
c                    DESCRIPTION
c
c     ISNaS Host Program
c
c***********************************************************************
c
c                   KEYWORDS
c
c     host_program
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c                   COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
c
c***********************************************************************
c
c                   SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c
c***********************************************************************
c
c                   I/O
c
c***********************************************************************
c
c                   ERROR MESSAGES
c
c***********************************************************************
c
c                   PSEUDO CODE
c
c          initialize local buffer
c          call ISNaS host main subroutine
c
c=======================================================================

      call ismain( nbuffr )

      end
      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

         if ( ichoice.eq.1 ) then
            usfunb = 2d0
         else if ( ichoice.eq.2 ) then
*            usfunb = 4d0 * y * ( 1d0-y) 
             usfunb =  z 
         end if

      end



