      program conc
c
c***********************************************************************
c
c                    DESCRIPTION
c
c     The rotating coordinate
c     concentric cylinder problem
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c                   COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
      call ismain( nbuffr )

      end
c
c***********************************************************************
c
c  The following user function calculates the source terms for a 
c  coordinate system rotating with a constant angular speed omega
c  in a counterclockwise direction about the z-axis.
c
      function usfunc1(ichoice,x,y,z,t,soluts,ndegfd)
      implicit none
      integer ichoice, ndegfd
      double precision omega,usfunc1,x,y,z,t,soluts(ndegfd)
      double precision rho,rad,A,ucalc,uexactn
      omega=-1.d0
      rho=1.d0
      rad=dsqrt(x*x+y*y)
      A=100.d0/99.d0
      uexactn=A*omega*(1.d0/rad-rad)
      ucalc=dsqrt(soluts(1)*soluts(1)+soluts(2)*soluts(2))
      if (ichoice .eq. 1) then
        usfunc1=-rho*(-2.d0*omega*soluts(2)-x*omega*omega)
*        if ((x .ge. 9.7) .and. (x .le. 9.80) .and. (y .ge. 0.0)) then 
*          write(*,*) 'ichoice,x,y,ucalc,vcalc,pcalc'
*          write(*,*) ichoice,x,y,soluts(1),soluts(2),soluts(3)
*          write(*,*) 'uthetaexact,uthetacalc'
*          write(*,*) uexactn,ucalc
*          write(*,*) 'usfunc1=',usfunc1
*        endif
      end if
      if (ichoice .eq. 2) then
        usfunc1=-rho*(2.d0*omega*soluts(1)-y*omega*omega)
*        if ((x .ge. 9.7) .and. (x .le. 9.8) .and. (y .ge. 0.0)) then 
*          write(*,*) 'ichoice,x,y,ucalc,vcalc,pcalc'
*          write(*,*) ichoice,x,y,soluts(1),soluts(2),soluts(3)
*          write(*,*) 'uthetaexact,uthetacalc'
*          write(*,*) uexactn,ucalc
*          write(*,*) 'usfunc1=',usfunc1
*        endif
      end if
      end

