      program isnasexe
c=======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-94
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c***********************************************************************
c
c                    DESCRIPTION
c
c     ISNaS Host Program
c
c***********************************************************************
c
c                   KEYWORDS
c
c     host_program
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c                   COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
c
c***********************************************************************
c
c                   SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c
c***********************************************************************
c
c                   I/O
c
c***********************************************************************
c
c                   ERROR MESSAGES
c
c***********************************************************************
c
c                   PSEUDO CODE
c
c          initialize local buffer
c          call ISNaS host main subroutine
c
c=======================================================================

      call ismain( nbuffr )

      end
      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

      logical ready
      integer i
      double precision ar(1:3,1:33), y1, y2, u1, u2, k1, k2, 
     +                 a1, b1, a2, b2,  u ,k ,eps, lscale,
     +                 kappa, H, cmu, omega

      H = 0.170
      kappa = 0.41
      cmu = 0.09

      ar(1,1) = 0
      ar(1,2) = 1
      ar(1,3) = 2 
      ar(1,4) = 4
      ar(1,5) = 7
      ar(1,6) = 9
      ar(1,7) = 11
      ar(1,8) = 13
      ar(1,9) = 16
      ar(1,10) = 21
      ar(1,11) = 26
      ar(1,12) = 31
      ar(1,13) = 41
      ar(1,14) = 51
      ar(1,15) = 61
      ar(1,16) = 71
      ar(1,17) = 85
      ar(1,18) = 99
      ar(1,19) = 109
      ar(1,20) = 119
      ar(1,21) = 129
      ar(1,22) = 139
      ar(1,23) = 144
      ar(1,24) = 149
      ar(1,25) = 154
      ar(1,26) = 157
      ar(1,27) = 159
      ar(1,28) = 161
      ar(1,29) = 163
      ar(1,30) = 166
      ar(1,31) = 168
      ar(1,32) = 169
      ar(1,33) = 170

      ar(2,1) = 1.0
      ar(2,2) = 1.274
      ar(2,3) = 1.392
      ar(2,4) = 1.521
      ar(2,5) = 1.622
      ar(2,6) = 1.671 
      ar(2,7) = 1.706
      ar(2,8) = 1.745
      ar(2,9) = 1.778
      ar(2,10) = 1.831
      ar(2,11) = 1.868
      ar(2,12) = 1.908
      ar(2,13) = 1.97
      ar(2,14) = 2.03
      ar(2,15) = 2.087
      ar(2,16) = 2.124
      ar(2,17) = 2.147
      ar(2,18) = 2.124
      ar(2,19) = 2.087
      ar(2,20) = 2.03
      ar(2,21) = 1.97
      ar(2,22) = 1.908
      ar(2,23) = 1.868
      ar(2,24) = 1.831
      ar(2,25) = 1.778
      ar(2,26) = 1.745
      ar(2,27) = 1.706
      ar(2,28) = 1.671
      ar(2,29) = 1.622
      ar(2,30) = 1.521
      ar(2,31) = 1.392
      ar(2,32) = 1.274
      ar(2,33) = 1.0

      ar(3,1) = 2.4000000D-02
      ar(3,2) = 2.3575000D-02
      ar(3,3) = 2.3050000D-02
      ar(3,4) = 2.1450000D-02
      ar(3,5) = 2.3115000D-02
      ar(3,6) = 2.2385000D-02
      ar(3,7) = 2.0570000D-02
      ar(3,8) = 1.9795000D-02
      ar(3,9) = 1.8645000D-02
      ar(3,10) = 1.6890000D-02
      ar(3,11) = 1.5795000D-02
      ar(3,12) = 1.4525000D-02
      ar(3,13) = 1.2720000D-02
      ar(3,14) = 1.0410000D-02
      ar(3,15) = 8.1475000D-03
      ar(3,16) = 6.4000000D-03
      ar(3,17) = 5.1250000D-03
      ar(3,18) = 6.4000000D-03
      ar(3,19) = 8.1475000D-03
      ar(3,20) = 1.0410000D-02
      ar(3,21) = 1.2720000D-02
      ar(3,22) = 1.4525000D-02
      ar(3,23) = 1.5795000D-02
      ar(3,24) = 1.6890000D-02
      ar(3,25) = 1.8645000D-02
      ar(3,26) = 1.9795000D-02
      ar(3,27) = 2.0570000D-02
      ar(3,28) = 2.2385000D-02
      ar(3,29) = 2.3115000D-02
      ar(3,30) = 2.1450000D-02
      ar(3,31) = 2.3050000D-02
      ar(3,32) = 2.3575000D-02
      ar(3,33) = 2.4000000D-02

      ready = .false.
      i = 1
      do while ( .not. ready .and. i .le. 32)

        y1 = ar(1,i)*1d-3
        y2 = ar(1,i+1)*1d-3
        u1 = ar(2,i)
        u2 = ar(2,i+1)
        k1 = ar(3,i)
        k2 = ar(3,i+1)
        if ( y .ge. y1 .and. y .le. y2 ) then

          a1 = (u1 - u2)/(y1 - y2)
          b1 = (u2*y1 - u1*y2)/(y1 - y2)
          u  = a1*y + b1

          a2 = (k1 - k2)/(y1 - y2)
          b2 = (k2*y1 - k1*y2)/(y1 - y2)
          k  = a2*y + b2

          ready = .true.

        end if

        i = i + 1

      end do

      if ( y .lt. 0.5*H ) then
        lscale = min(kappa*y, 0.1*0.5*H)
      else
        lscale = min(kappa*(H-y), 0.1*0.5*H)
      end if

      if ( lscale .eq. 0d0 ) then
        eps = 1d4
      else
        eps = (cmu**75d-2)*(k**15d-1)/lscale
      end if

      if ( lscale .eq. 0d0 ) then
        omega = 1d4
      else
        omega = sqrt(k)/lscale
      end if

      if ( ichoice .eq. 1 ) then
        usfunb = -u
      else if ( ichoice .eq. 2 ) then
        usfunb =  k
      else if ( ichoice .eq. 3 ) then
        usfunb =  eps 
      else if ( ichoice .eq. 4 ) then
        usfunb =  omega
      end if

      end


