      program sepmesh
c ======================================================================
c
c        programmer     Guus Segal
c        version 2.1    date   30-04-1995 Removal of buffer
c        version 2.0    date   11-11-1990 Complete reorganization
c        version 1.0    date   26-03-1988
c
c
c
c   copyright (c) 1988-1995  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c      Program sepmesh reads an input file containing information of the
c      mesh, and generates a SEPRAN mesh
c      The mesh is written to the meshoutput file as indicated in the
c      sepran.env file
c **********************************************************************
c
c                       KEYWORDS
c
c    create
c    mesh
c    plot
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c    SEPMSH  Performs the actual mesh generation
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call sepmsh(0)
      end

      subroutine funccv( icurve, t, x, y, z)

      implicit none

c     input/output parameters

      integer icurve
      double precision t, x, y, z

c     local parameters

      double precision f, c, r

c
c     --- naca0012 profile
c
      c = 1.008930411365d0

 
      f = .21d0

      x = t

      r = t*c

      y = 5d0*f*(.2969d0*sqrt(r) - .126d0*r - .3516d0*r**2d0 +
     +    .2843d0*r**3d0 - .1015d0*r**4d0)

      end 		
