      subroutine isflc3 ( choice, coefs, ncoefs, icoef, ni, nj, nk,
     +                    nvirtual, coor, solut, ndegfd, time )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date 03-02-1998
c
c   copyright (c) 1998-1998  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     coefficients will be filled with a user supplied function
c
c **********************************************************************
c
c                       KEYWORDS
c
c     coefficients
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer choice, ni, nj, nk, ncoefs, icoef, ndegfd, nvirtual
      double precision coefs(1-nvirtual:ni+1+nvirtual,
     +                       1-nvirtual:nj+1+nvirtual,
     +                       1-nvirtual:nk+1+nvirtual,1:ncoefs),
     +                 coor(1-nvirtual:ni+1+nvirtual,
     +                      1-nvirtual:nj+1+nvirtual,
     +                      1-nvirtual:nk+1+nvirtual,*),
     +                 solut(1-nvirtual:ni+1+nvirtual,
     +                       1-nvirtual:nj+1+nvirtual,
     +                       1-nvirtual:nk+1+nvirtual,1:ndegfd,1:2),
     +                 time

c     choice    i    General choice parameter
c     coefs     o    reserved
c     coor      i    reserved
c     icoef     i    Sequence number of coefficient
c     ncoefs    i    Number of coefficients
c     ndegfd    i    Number of degrees of freedom
c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     nk        i    Number of non-virtual cells in the k-direction (one block)
c     nvirtual  i    Number of rows of virtual cells
c     solut     i    reserved
c     time      i    Actual time of time step
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ip, jp, kp, i
      double precision coorloc(3), work(100)

c     coorloc   Array containing the local coordinates of a point
c     i         General loop variable
c     ip        Local counting variable i-direction
c     jp        Local counting variable j-direction
c     kp        Local counting variable k-direction
c     work      Work array
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
      double precision usfunc, usfunc1

c     USFUNC    User supplied function to fill coefficients
c     USFUNC1   User supplied function to fill coefficients
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do kp = 1, nk
         do jp = 1, nj
            do ip = 1, ni
               do i = 1, 3
                  coorloc(i) = 0.125d0 * ( coor(ip,jp,kp,i)+
     +                                     coor(ip+1,jp,kp,i)+
     +                                     coor(ip,jp+1,kp,i)+
     +                                     coor(ip+1,jp+1,kp,i)+
     +                                     coor(ip,jp,kp+1,i)+
     +                                     coor(ip+1,jp,kp+1,i)+
     +                                     coor(ip,jp+1,kp+1,i)+
     +                                     coor(ip+1,jp+1,kp+1,i))
               end do

               if ( choice.lt.100 ) then

                  coefs(ip,jp,kp,icoef) =  usfunc ( choice,
     +                coorloc(1),coorloc(2), coorloc(3), time )

               else if ( choice.gt.100 .and. choice.lt.200 ) then

                  do i = 1, ndegfd
                     work(i) = solut(ip,jp,kp,i,1)
                  end do
                  coefs(ip,jp,kp,icoef) = usfunc1(choice-100,
     +                coorloc(1),coorloc(2), coorloc(3), time,
     +                work, ndegfd )

               end if

            end do

         end do

      end do

      end
