      subroutine ismulmsfr ( mu, massfrac, ni, nj, nvirtual )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date 26-11-1997
c
c
c   copyright (c) 1997-1997  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Multiply mu * massfrac and store in mu
c
c **********************************************************************
c
c                       KEYWORDS
c
c    coefficients
c    multiplication
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ni, nj, nvirtual
      double precision mu(1-nvirtual:ni+1+nvirtual,
     +                    1-nvirtual:nj+1+nvirtual)
      double precision massfrac(1-nvirtual:ni+1+nvirtual,
     +                          1-nvirtual:nj+1+nvirtual)

c     massfrac  o    Array containing the mass fraction
c     mu       i/o   The laminar viscosity
c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     nvirtual  i    Number of rows of virtual cells
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, j

c     i         General loop variable
c     j         General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do j = 2-nvirtual, nj+nvirtual-1
        do i = 2-nvirtual, ni+nvirtual-1
           mu(i,j) = mu(i,j)*massfrac(i,j)
        end do
      end do

      end
