      subroutine isstcr04(ntrnsp, nturb, ntype, norms1, norms2)
c ======================================================================
c
c     programmer   Erik Brakkee
c
c
c     version      1.1  11-03-1997  Kees K:  ntype added
c     version      1.0  13-7-1994  Erik:  initial revision
c
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Join computed sums and maxima stored in the norms arrays
c
c **********************************************************************
c
c                       KEYWORDS
c
c     stop_criterium
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ntrnsp, nturb, ntype
      double precision norms1(2+ntrnsp+nturb, 2)
      double precision norms2(2+ntrnsp+nturb, 2)

c     norms1    i   Array containing the computed norms
c                   norms(ieq,*) contains the norms for equation ieq
c     norms2    i/o Array containing computed norms
c     ntrnsp    i   Number of transport equations
c     nturb     i   Number of extra transport equations for turbulence
c     ntype     i  Type of norm used for stopcriterium
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ieq

c     ieq       Equation number
c **********************************************************************
c
c                       I/O
c
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      if ( ntype.eq.0 ) then

c     --- L2norm

         do ieq = 1, 2 + ntrnsp + nturb
            norms1(ieq,1) = norms1(ieq,1) + norms2(ieq,1)
            norms1(ieq,2) = norms1(ieq,2) + norms2(ieq,2)
         end do

      else if ( ntype.eq.1 ) then

c     --- Maxnorm

         do ieq = 1, 2 + ntrnsp + nturb
            norms1(ieq,1) = max( norms1(ieq,1), norms2(ieq,1))
            norms1(ieq,2) = max( norms1(ieq,2), norms2(ieq,2))
         end do

      end if

      end
