      subroutine calcres3 ( mat3, sol, rhs, res, nxa, nya, nza, matsol,
     +  sl1, sl2, sl3, sl4, sl5, sl6)
c ======================================================================
c
c        programmer     Jos van Kan
c        version 1.1    date   04-06-1997
c           isnazification of all variables and subroutine calls
c           all truncated to max 8 characters.
c        version 1.0    date   10-03-1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c   calculates b - Ax on actual level
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer sl1, sl2, sl3, sl4, sl5, sl6
      integer nxa, nya, nza
      double precision
     + mat3 (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6, 27),
     + sol (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6),
     + rhs (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6),
     + res (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6),
     + matsol (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6)

c     mat3      i    The nx x ny x nz x 27  coefficient matrix of the
c                    discrete Laplacian
c     matsol    o    vector with mat * sol
c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     nza       i    Number of grid z points on this level
c     res       o    Residual (any level)
c     rhs       i    Right hand side  (any level)
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c     sl5       i    Slack variable, z lower bound
c     sl6       i    Slack variable, z upper bound
c     sol       i    Solution vector (any level)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MMV3      Matrix vector mult (any level) 27 pt stencil (MG3)
c     SUBTVEC3  Calculates x - y, x and y vectors (MG3)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c   trivial
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call mmv3  ( mat3, sol, matsol, nxa, nya, nza,
     +  sl1, sl2, sl3, sl4, sl5, sl6)
      call subtvec3 ( rhs, matsol, res, nxa, nya, nza,
     +  sl1, sl2, sl3, sl4, sl5, sl6)
      end
