      subroutine v1step3  ( mat3, res, nsmooth, sol, rbuf, ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c       version 1.2    date  8- 7-1997
c       version 1.1    10-04-1997
c        version 1.0    date Tue Apr  8 1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    3D Preconditioner for mat3 based on a multigrid V-cycle
c    with 3 way alternating Line Jacobi as smoother.
c   Result in sol.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid preconditioner V-cycle line-jacobi smoother
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf (*)
      double precision mat3 (*), res (*), sol(*), rbuf (*)
      integer nsmooth

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c     mat3      i    The nx x ny x nz x 27  coefficient matrix of the
c                    discrete Laplacian
c     nsmooth   i    Number of times smoother is applied (all levels)
c     rbuf      i    Buffer array used to store all coarse size info
c                    and as scratch space. The actaul bufferspace
c                    needed can be calculated using subr autosize.
c     res       i    Residual (any level)
c     sol       o    Solution vector (any level)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      print *, ' You need a FORTRAN-90 compiler to use multigrid'
      stop
      end
