      subroutine ispri105 ( infmat, matrix, text )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date 01-06-94
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                      DESCRIPTION
c
c     Print the contents of array matrix
c     Actual printing subroutine
c ********************************************************************
c
c                      KEYWORDS
c
c    print
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer infmat(*)
      double precision matrix(*)
      character *(*) text

c     infmat    i    reserved
c     matrix    i    reserved
c     text      i    String in which a text is stored
c ********************************************************************
c
c                      COMMON BLOCKS
c
       include 'IScommon/cisnas'
c ********************************************************************
c
c                      LOCAL PARAMETERS
c
      integer i, ipmatrix, iseq, j, nconct, ndim, ni, nj, nk

c     i         General loop variable
c     ipmatrix  Starting address of array matrix in BUFFER
c     iseq      Sequence number of matrix
c     j         General loop variable
c     nconct    Number of connections in a row of the matrix
c     ndim      dimension of the problem
c     ni        i-dimension of a block
c     nj        j-dimension of a block
c     nk        k-dimension of a block
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c     ISPRAR01  Print general field array defined in R2
c     ISPRAR02  Print general field array defined in R3
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c    Print heading
c    Extract iseq, ndim, ni, nj, nk, n, nconct
c    Print infmat and matrix
c ======================================================================
c
c     --- Print heading

      write(irefwr,100) text
100   format(//1x,a)

c     --- Extract iseq, ndim, ni, nj, nk, n, nconct

      iseq   = infmat(1)
      ni     = infmat(2)
      nj     = infmat(3)
      nk     = infmat(4)
      ndim   = infmat(5)
      nconct = infmat(6)
      if ( ndim.eq.1 ) then

c     --- only one unknown (transport or pressure matrix)

         write(irefwr,110) iblockrf,
     +       (infmat(10+(iseq-1)*ndim*nconct+i),i=1,nconct)
110      format(//' Shifts for array matrix for block number', i4 //
     +          (1x,10i6) )
         write(irefwr,120)
120      format(' Contents of array matrix' )

c        --- Print matrix

         if ( nk.eq.0 ) then

c        --- ndim = 2

            call isprar01 ( matrix, 0, ni, nj, nconct )

         else

c        --- ndim = 3

            call isprar02 ( matrix, 0, ni, nj, nk, nconct )

         end if

      else

c     --- momentum matrix

         do j = 1, ndim
            write(irefwr,130) iblockrf, j,
     +     (infmat(10+(iseq-1)*ndim*nconct+i+(j-1)*nconct),i=1,nconct)
130         format(//' Shifts for array matrix for block number', i4,
     +               ' and unknown no',i3// (1x,10i6) )
            write(irefwr,120)

c           --- Print matrix

            if ( nk.eq.0 ) then

c           --- ndim = 2

               ipmatrix = 1+(j-1)*(ni+1)*(nj+1)*nconct
               call isprar01 ( matrix(ipmatrix), 0, ni, nj, nconct )

            else

c           --- ndim = 3

               ipmatrix = 1+(j-1)*(ni+1)*(nj+1)*(nk+1)*nconct
               call isprar02 ( matrix(ipmatrix), 0, ni, nj, nk, nconct )

            end if

         end do

      end if

      end
