      subroutine isprirh1 ( text, rhside, ni, nj, ndegfd )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date 13-02-95
c
c
c   copyright (c) 1995-1995  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                      DESCRIPTION
c
c     Print the contents of the array rhside on a two-dimensional grid
c
c     The heading of the output is given by text
c
c     This subroutine is meant for debug purposes. It is assumed that the
c     rhside and the dimension parameters are available.
c ********************************************************************
c
c                      KEYWORDS
c
c    2d
c    right_hand_side
c    print
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer ni, nj, ndegfd
      double precision rhside(*)
      character *(*) text

c     ndegfd    i    Number of degrees of freedom
c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     rhside    i    reserved
c     text      i    String in which a text is stored
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/cisnas'
c ********************************************************************
c
c                      LOCAL PARAMETERS
c
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c     ISPRAR01  Print general field array defined in R2
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c ======================================================================
c
      write(irefwr,100) text, iblockrf
100   format( a / ' Block number ', i4 )
      call isprar01 ( rhside, 0, ni, nj, ndegfd )
      end
