      subroutine isersend ( msgnum, nints, nreal, nchar, icontext )
c ======================================================================
c
c        Programmer     Jason Frank
c        version 1.1    date 05-10-1999 added send-requests
c        version 1.0    date 13-11-1998 Send error information to host
c
c     copyright (c) 1998-1999  "Ingenieursbureau SEPRA"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "Ingenieursbureau SEPRA"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Sends error description from node
c
c **********************************************************************
c
c                       KEYWORDS
c
c     error_manipulation
c     parallel
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer msgnum, nints, nreal, nchar, icontext

c     icontext i  message tag ( in { ISERCTXT, ISWRCTXT } )
c     msgnum   i  Message sequence number.
c     nchar    i  Number of strings in a message
c     nints    i  Number of integers in a message
c     nreal    i  Number of reals in a message
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cismessg'
      include 'IScommon/cismessc'
      include 'IScommon/ciscom'
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ireq(5)

c     ireq        array of send-requests
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISSENCHR       Wrapper for MPI_SEND
c     ISSENMPI       send function
c     ISWAITALL      Wait for all sends to complete
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c

      info(2) = msgnum
      info(3) = nints
      info(4) = nreal
      info(5) = nchar
      info(6) = levelsub
      info(8) = iblockrf
      info(9) = inodenr

      call issenmpi ( info, 10, ISINT, ISHOST, icontext, ireq(1) )

      call issenchr ( namsubs, info(6)*8, ISCHAR, ISHOST, icontext,
     +                  ireq(2) )

      call issenmpi ( ints, nints, ISINT, ISHOST, icontext, ireq(3) )

      call issenmpi ( reals, nreal, ISDOUBLE, ISHOST, icontext,
     +                ireq(4) )

      call issenchr ( chars, nchar, ISCHAR, ISHOST, icontext,
     +                ireq(5) )

      call iswaitall ( 5, ireq )

      end
