      function isbcread ( nncode, table )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date 28-07-94
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                      DESCRIPTION
c
c    Check to see if boundary conditions have been read by the last
c    call to isintx02
c
c ********************************************************************
c
c                      KEYWORDS
c
c       boundary_conditions
c       read
c       read_cards
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer nncode
      double precision table(nncode)
      logical isbcread

c     isbcread  i  Return value, TRUE if boundary conditions have been
c                  read, FALSE otherwise
c     nncode    i  Number of subkeywords stored in array code
c     table     i  Array containing the real or integer values corresponding to
c                  the subkeywords in code that have been read by isintx02
c
c ********************************************************************
c
c                      COMMON BLOCKS
c
c     None
c ********************************************************************
c
c                      LOCAL PARAMETERS
c
      integer i

c     i         General loop variable
c
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c    None
c ********************************************************************
c
c                      I/O
c
c    None
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c    None
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c
c
c ********************************************************************
c
c                      DATA STATEMENTS
c     None
c
c ======================================================================
c

      isbcread = .false.

      do i = 1, nncode

        if ( table(i) .gt. -1d20 ) isbcread = .true.

      enddo

      end
