      subroutine isrddisc ( nmain, codemn, nmcode, iretur, iindsc,
     +                      rindsc, maxtrans, maxturb, icheckeq,
     +                      iseqeq )
c ======================================================================
c
c        programmer     Guus Segal
c        version 2.16   date 05-01-2000 Guus: correction iseqeq
c        version 2.15   date 21-10-1999 Guus: extra keyword skip_continuity
c        version 2.14   date 15-07-1999 Guus: extend nmainnw
c        version 2.13   date 29-03-1999 Duncan: change error 605 to
c                                               warning, still error mess. in
c                                               main program, initialize keyprev
c                                               iseqprev
c        version 2.12   date 22-03-1999 Guus: extend nmainnw
c        version 2.11   date 02-02-1999 Kees K: extension with axisymmetric
c        version 2.10   date 05-01-1999 Guus: adapt comment
c        version 2.9    date 26-03-1998 Guus: extension with BILIEAR_INTERPOL.
c        version 2.8    date 16-03-1998 Kees K value table(12)=2d0 changed
c                                       in 1.5d0, and for TVD rindsc(4,i)
c                                       changed from table(10) to
c                                       -table(13)
c        version 2.7    date 03-03-1998 Guus extra keyword conservative
c        version 2.6    date 11-12-1997 Guus copy type of discretization
c                                       for all equations
c        version 2.5    date 17-07-1997 Guus extension with coupled/decoupled
c        version 2.4    date 17-02-1997 Marcel extension flux limiters, part II
c        version 2.3    date 10-12-1996 Marcel extension flux limiters
c        version 2.2    date 13-06-1996 Guus new definition of discr_...
c        version 2.1    date 04-06-1996 Marcel Error 606
c        version 2.0    date 18-10-1995 Marcel  extension flux limiters
c        version 1.5    date 15-03-1995 Kees K  buf fixed for noconvection
c        version 1.4    date 08-03-1995 Kees K  iseqeq added
c        version 1.3    date 07-03-1995 Error correction print
c        version 1.2    date 21-02-1995 Extra keywords print
c        version 1.1    date 07-02-1995 Extra keyword linear_convection
c        version 1.0    date 28-07-1994
c
c
c   copyright (c) 1994-2000  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Read discretization part of input files and store result in
c    arrays iindsc and rindsc
c **********************************************************************
c
c                       KEYWORDS
c
c       discretization
c       read
c       read_cards
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer nmain, nmcode(nmain), iretur, maxtrans, maxturb,
     +        iindsc(100,maxtrans+1+maxturb),
     +        icheckeq(maxtrans+1+maxturb) ,
     +        iseqeq(maxtrans+2+maxturb)
      double precision rindsc(100,maxtrans+1+maxturb)
      character *(*) codemn(nmain)

c     codemn    i    Table of main keywords
c     icheckeq  i    Work array to indicate if an equation has been considered
c                    (icheckeq(i)=1 or not icheckeq(i)=0)
c     iindsc    o    reserved
c     iretur    o    Return code, indicates the sequence number of the new
c                    main keyword found
c                    If -1 an error has occurred
c                    If -2 the end of file has been reached
c     iseqeq    o    Array with sequence numbers of equations
c     maxtrans  i    Maximum number of transport equations allowed
c     maxturb   i    Maximum number of turbulence equations allowed
c     nmain     i    Number of keywords in array codemn
c     nmcode    i    Array containing the number of significant characters
c                    for each main keyword in codemn
c     rindsc    o    reserved
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cseprd'
      include 'IScommon/csepch'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer nmainnw, newmain, lenchar, nncode, nncod2, nout
      parameter ( nmainnw=80, newmain=3, nncode=25, nncod2=45,
     +            lenchar=14, nout=3 )
      integer nmcode1(newmain), nmcoda(nmainnw), itype(nncode),
     +        nmcode2(nncod2), ncodmx(nncode), nstrng, inum,
     +        ncode(nncode), i, iequa, ih, iseq, iseqprev, keyprev,
     +        limiter, maxt, nmain1, nmmaintot, numsub, lshift
      double precision table(nncode), tabmin(nncode), tabmax(nncode),
     +                 tabout(nout)
      character *14 codema(nmainnw), code1(newmain)
      character *22 code2(nncod2)
      character *24 code(nncode)
      character *1 strout(1)
      logical ready

c     code           Table containing the subkeywords corresponding to this
c                    subroutine.
c     code1          Table containing the  main keywords corresponding to
c                    this subroutine.
c     code2          Table containing the  subsubkeywords corresponding to
c                    this subroutine.
c     codema         Table consisting of the local main keywords followed
c                    by the general main keywords possibly followed by the
c                    subsubkeywords
c     i              General loop variable
c     iequa          General equation sequence number
c     ih             Help variable to store a constant temporarily
c     inum           Indicates the number of numbers that have been read
c     iseq           Sequence number read after transport or turbulence
c                    equation
c     iseqprev       Previous value of iseq
c     itype          Array containing the type of actions to be undertaken
c                    for each subkeyword found.
c                    See subroutine isintx02 for the possible values
c                    of itype
c     keyprev        Sequence number of previous keyword found with respect
c                    to code
c     lenchar        Number of characters in main keywords
c     limiter        Sequence number of keyword found after keyword limiter
c     lshift         Local shift
c     maxt           Maximum number of equations allowed for a specific
c                    type
c                    With respect to transport: maxtrans-10
c                    With respect to turbulence: 10
c     ncode          Array containing the number of significant characters
c                    for each keyword in code
c     ncodmx         Array containing the maximum number of characters for
c                    each keyword in code
c     newmain        Number of main keywords stored in array code1
c     nmain1         Total number of main keywords (newmain+nmain)
c     nmainnw        Maximal number of keywords in codema
c     nmcoda         Array containing the number of significant characters
c                    for each keyword in codema
c     nmcode1        Array containing the number of significant characters
c                    for each keyword in code1
c     nmcode2        Array containing the number of significant characters
c                    for each keyword in code2
c     nmmaintot      Total number of keywords in codema
c     nncod2         Number of subsubkeywords stored in array code2
c     nncode         Number of subkeywords stored in array code
c     nout           Length of array tabout
c     nstrng         Length of array strout
c     numsub         Number of subkeywords that may be detected by isintx02
c                    In the first step numsub=0 for any other step
c                    numsub=nncode
c     ready          Indicates if a while loop is finished or not
c     strout         Contains series of strings, see itype
c     table          Array containing the real or integer values
c                    corresponding to the subkeywords in code that
c                    have been read by isintx02
c     tabmax         Array containing the maximal values of the parameters
c                    read corresponding to the subkeywords in code
c     tabmin         Array containing the minimum values of the parameters
c                    read corresponding to the subkeywords in code
c     tabout         Array of output reals provided by isintx02
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISASKNXT  Read next item from the standard input file
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRCHR  Puts values of strings in character error array
c     ISERRCRD  Prints the last record read and underlines the erroneous part
c     ISERRINT  Put integer value in error message
c     ISERRSUB  Error messages
c     ISINTX02  Interpret a record containing keywords followed by numbers
c     ISSTOP    Stop ISNAS
c     ISWARSUB  Print warnings
c **********************************************************************
c
c                       I/O
c
c    This subroutine reads the input after the main keyword DISCRETIZATION
c    until a new main keyword has been found
c
c    The following input is recognized:
c
c    MOMentum_equations
c    TRANSport_equation i or all
c    TURBulence_equation i or all
c
c    These keywords itself may be followed by subkeywords that indicate
c    whether these equations or part of it are skipped and which type of
c    discretization is used.
c    The following subkeywords are recognized:
c
c    AXisymmetric
c    SKIP/NOSKIP
c    SKIP_CONTINUITY_EQUATION
c    DECOUPLED/COUPLED
c    CONVection/NOCONVection
c    CONSERvative
c    DISCR_METhod = type1
c    UPWind = type4
c    DIFFusion = type5
c    LIN_CONvection = type7
c    PRINT_MATrix
c    PRINT_GMATrix
c    PRINT_PMATrix
c    PRINT_VECtor
c    PRINT_PVECtor
c    PRINT_STeps = (itime1,itime2,itstep)
c
c    type1 may take one of the following values:
c       CLAssical
c       WESBeek
c       REDuced
c       BILinear_interpolation
c
c    type4 may take one of the following values:
c
c       NONe
c       FIRst_order
c       HYBrid
c       HIGher_order
c          Must be followed by the keyword KAPpa = k
c       TVD
c          Must be followed by the keyword LIMiter = limtype, where
c          limtype may take one of the following values:
c                        SWEBy_phi_limiter possibly followed by:
c                           PHI = phi
c                        R_Kappa_limiter possibly followed by:
c                           KAPpa = k
c                        MR_Kappa_limiter possibly followed by:
c                           KAPpa = k
c                        SYMM_Ratio_limiter possibly followed by:
c                           MBOUnd = m
c                        PL_Kappa_limiter possibly followed by:
c                           KAPpa = k, MBOUnd = m, ALPha = a
c                        MPLONE_Kappa_limiter possibly followed by:
c                           KAPpa = k, MBOUnd = m, ALPha = a
c                        MPLTWO_Kappa_limiter possibly followed by:
c                           KAPpa = k, MBOUnd = m, ALPha = a
c                        SYMM_PL_kappa_limiter possibly followed by:
c                           KAPpa = k, MBOUnd = m
c       LUDs
c       QUIck
c       CUI
c       FROmm
c       MINmod
c       SUPerbee
c       VAN_Leer
c       ISNas
c       KORen
c       SMArt
c       UMIst
c       MUScl
c       DAVis
c       HLPa
c       SOUcup
c       BSOu
c       NOTable
c       HARmonic
c       VAN_Albada
c       OSPre
c
c    type5 may take one of the following values:
c
c       STandard
c       HALF_MOnotone
c       MOnotone
c
c    type7 may take one of the following values:
c       NEWton
c       PICard
c **********************************************************************
c
c                       ERROR MESSAGES
c
c     528   No integer number has been found after the keyword %
c     530   integer number read out of range
c     531   Internal error in subroutine; character array too small
c     532   Both skip and noskip have been found
c     533   Both convection and noconvection have been found
c     567   Equation has been found more than once
c     587   two keywords found that are mutually exclusive
c     606   Combination of UPWIND and NEWTON have been found
c     628   Both the keywords SKIP_CONTINUITY_EQUATION and NOSKIP have been
c           found for the momentum equations.
c     629   The keyword SKIP_CONTINUITY_EQUATION has been found for another
c           equation than the momentum equations.
c     718   Subkeyword is used without the combination of the corresponding
c           keyword
c **********************************************************************
c
c                       PSEUDO CODE
c
c    Make table of new main keywords consisting of the local main keywords
c    and the global main keywords and the subsubkeywords
c    ready := false
c    number_of_subkeywords := 0
c    while ( not ready ) do
c       iseq := 0
c       Read next subkeywords until a new main keyword is found
c       if ( main keyword = transport or turbulence ) then
c          Read sequence number iseq
c       if ( number_of_subkeywords=0 ) then
c          number_of_subkeywords := actual number
c       else
c          interpret subkeywords as function of keyword_previous
c       if ( keyword found = main keyword ) then
c          ready := true
c       keyword_previous := keyword found
c       iseq_previous := iseq
c
c    Remark:
c
c      The first array iindsc/rindsc(.,1) corresponds to the momentum equations
c      The arrays iindsc/rindsc(.,2 to maxtrans+1) correspond to the transport
c      equations 1 to maxtrans
c      The arrays iindsc/rindsc(maxtrans+2 to maxtrans+1+maxturb) correspond to
c      the transport equations 1 to 10
c **********************************************************************
c
c                       DATA STATEMENTS
c
      data code1 / 'MOMENTUM_EQ', 'TRANSPORT_EQ', 'TURBULENCE_EQ' /
      data nmcode1 / 3, 4, 12 /
      data code  / 'SKIP_CONTINUITY_EQUATION', 'NOSKIP', 'CONVECTION',
     +             'NOCONVECTION', 'DISCR_METHOD',
     +             'DISCR_PRESSURE', 'UPWIND', 'DIFFUSION',
     +             'LIMITER', 'ALPHA', 'PHI', 'MBOUND',
     +             'KAPPA', 'LIN_CONVECTION', 'PRINT_MATRIX',
     +             'PRINT_GMATRIX', 'PRINT_PMATRIX', 'PRINT_VECTOR',
     +             'PRINT_PVECTOR', 'PRINT_STEPS','DECOUPLED',
     +             'COUPLED', 'CONSERVATIVE', 'AXISYMMETRIC', 'SKIP' /
      data ncode  / 9, 6,  4,  6,  9,   10, 3,  4, 3,  3,
     +              3, 4,  3,  7,  9,   10,10,  9,10,  8,
     +              6, 4,  7,  2,  4 /
      data ncodmx /24, 6, 10, 12, 12,   14, 6,  9, 7,  5,
     +              3, 6,  5, 14, 12,   13,13, 12,13, 11,
     +              9, 7, 12, 12,  4/
      data itype  / 2, 2,  2,  2,  5,    5, 5, 5,  5,  1,
     +              1, 1,  1,  5,  2,    2, 2, 2,  2, 11,
     +              2, 2,  2,  2,  2 /
      data tabmin / 9*0d0, -1d0, 1d0, 1d0, -1d0, 6*0d0, 3d0, 5*0d0 /
      data tabmax / 9*0d0,  0d0, 2d0, 1d1,  1d0, 6*0d0, 1d4, 5*0d0 /
      data code2 / 'CLASSICAL', 'WESBEEK', 'REDUCED',
     +             'BILINEAR_INTERPOLATION',
     +             'BERNARDKAPITZA', 'WESBEEK',
     +             'WESBBEEK', 'NONE', 'FIRST_ORDER', 'HYBRID',
     +             'HIGHER_ORDER', 'TVD', 'LUDS', 'QUICK',
     +             'CUI', 'FROMM', 'MINMOD', 'SUPERBEE', 'VAN_LEER',
     +             'ISNAS', 'KOREN', 'SMART', 'UMIST', 'MUSCL',
     +             'DAVIS', 'HLPA', 'SOUCUP', 'BSOU', 'NOTABLE',
     +             'HARMONIC', 'VAN_ALBADA', 'OSPRE',
     +             'STANDARD', 'HALF_MONOTONE','MONOTONE',
     +             'SWEBY_PHI_LIMI', 'R_KAPPA_LIMIT', 'MR_KAPPA_LIM',
     +             'SYMM_RATIO_LIM', 'PL_KAPPA_LIMIT','MPLONE_KAPPA',
     +             'MPLTWO_KAPPA', 'SYMM_PL_KAPPA', 'NEWTON',
     +             'PICARD' /
      data nmcode2 / 3, 5, 3, 3, 3,    5, 5, 3, 3, 3,   3, 3, 3, 3, 3,
     +               3, 3, 3, 5, 3,    3, 3, 3, 3, 3,   3, 3, 3, 3, 3,
     +               5, 3, 2, 7, 2,    4, 3, 4, 6, 4,   8, 8, 7, 3, 3 /

c     code      Table containing the subkeywords corresponding to this
c               subroutine. Contents:
c               1:  SKIP_CONTINUITY_EQUATION
c               2:  NOSKIP
c               3:  CONVECTION
c               4:  NOCONVECTION
c               5:  DISCR_METHOD
c               6:  DISCR_PRESSURE        superfluous
c               7:  UPWIND
c               8:  DIFFUSION
c               9:  LIMITER
c              10:  ALPHA
c              11:  PHI
c              12:  MBOUND
c              13:  KAPPA
c              14:  LIN_CONVECTION
c              15:  PRINT_MATRIX
c              16:  PRINT_GMATRIX
c              17:  PRINT_PMATRIX
c              18:  PRINT_VECTOR
c              19:  PRINT_PVECTOR
c              20:  PRINT_STEPS
c              21:  DECOUPLED
c              22:  COUPLED
c              23:  CONSERVATIVE
c              24:  AXISYMMETRIC
c              25:  SKIP
c     code1     Table containing the  main keywords corresponding to this
c               subroutine. Contents:
c               1:  MOMENTUM_EQUATION
c               2:  TRANSPORT_EQUATION
c               3:  PRESSURE_EQUATION
c               4:  TURBULENCE_EQUATION
c     code2     Table containing the  subsubkeywords corresponding to this
c               subroutine. Contents:
c               1:  CLASSICAL
c               2:  WESBEEK
c               3:  REDUCED
c               4:  REDUCED
c               5:  BILINEAR_INTERPOLATION
c               6:  -
c               7:  -
c               8:  NONE
c               9:  FIRST_ORDER
c              10:  HYBRID
c              11:  HIGHER_ORDER
c              12:  TVD
c              13:  LUDS
c              14:  QUICK
c              15:  CUI
c              16:  FROMM
c              17:  MINMOD
c              18:  SUPERBEE
c              19:  VAN_LEER
c              20:  ISNAS
c              21:  KOREN
c              22:  SMART
c              23:  UMIST
c              24:  MUSCL
c              25:  DAVIS
c              26:  HLPA
c              27:  SOUCUP
c              28:  BSOU
c              29:  NOTABLE
c              30:  HARMONIC
c              31:  VAN_ALBADA
c              32:  OSPRE
c              33:  STANDARD
c              34:  HALF_MONOTONE
c              35:  MONOTONE
c              36:  SWEBY_PHI_LIMITER
c              37:  R_KAPPA_LIMITER
c              38:  MR_KAPPA_LIMITER
c              39:  SYMM_RATIO_LIMITER
c              40:  PL_KAPPA_LIMITER
c              41:  MPLONE_KAPPA_LIMITER
c              42:  MPLTWO_KAPPA_LIMITER
c              43:  SYMM_PL_KAPPA_LIMITER
c              44:  NEWTON
c              45:  PICARD
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c
      call iseropen ( 'isrddisc' )

c     --- Make table of new main keywords consisting of the local main keywords
c         and the global main keywords and the subsubkeywords

      nmain1 = newmain+nmain
      nmmaintot = nmain1+nncod2
      if ( nmmaintot.gt.nmainnw ) then

c     --- Error nmainnw too small

         call iserrint ( nmainnw, 1 )
         call iserrint ( nmain, 2 )
         call iserrint ( newmain, 3 )
         call iserrsub ( 531, 3, 0, 0 )
         call isstop

      end if

      do i = 1, newmain
         codema(i)(1:lenchar) = code1(i)(1:lenchar)
         nmcoda(i) = nmcode1(i)
      end do
      do i = 1, nmain
         codema(i+newmain)(1:lenchar) = codemn(i)(1:lenchar)
         nmcoda(i+newmain) = nmcode(i)
      end do
      do i = 1, nncod2
         codema(i+nmain1)(1:lenchar) = code2(i)(1:lenchar)
         nmcoda(i+nmain1) = nmcode2(i)
      end do

c     --- Clear array icheckeq

      do i = 1, maxtrans+1+maxturb
         icheckeq(i) = 0
      end do

c     --- Initialize iindsc(1,.)

      do i = 1, maxtrans+1+maxturb
         iindsc(1,i) = 1
      end do

c     --- Set tabmin and tabmax with references of sub subkeywords
c         stored in codema

      tabmin(5) = nmain1+1
      tabmax(5) = tabmin(5)+3
      tabmin(6) = tabmax(5)+1
      tabmax(6) = tabmin(6)+2
      tabmin(7) = tabmax(6)+1
      tabmax(7) = tabmin(7)+24
      tabmin(8) = tabmax(7)+1
      tabmax(8) = tabmin(8)+2
      tabmin(9) = tabmax(8)+1
      tabmax(9) = tabmin(9)+7
      tabmin(14) = tabmax(9)+1
      tabmax(14) = tabmin(14)+1
      ready    = .false.
      numsub   = 0
      keyprev  = 0
      iseqprev = 0

200   if ( .not. ready ) then

c     --- while loop ready

         iseq = 0

c        --- Read next subkeywords until a new main keyword is found

         do i = 1, numsub
            table(i) = -1d2
         end do
         table(10) = 0d0
         table(11) = 1d0
         table(12) = 1.5d0
         table(13) = 5d-1
         table(15) = 0d0
         table(16) = 0d0
         table(17) = 0d0
         table(18) = 0d0
         table(19) = 0d0
         table(23) = 0d0
         table(24) = 0d0
         tabmax(20) = 1d4
         nstrng = 1
         call isintx02 ( code, ncode, numsub, itype, table, codema,
     +                   nmcoda, nmain1, iretur, tabmin, tabmax,
     +                   tabout, nout, strout, nstrng, ncodmx )

         if ( iretur.eq.2 .or. iretur.eq.3 ) then

c        --- transport or turbulence found
c            Read sequence number iseq

            call isasknxt
            if ( ityprd.eq.2 ) then

c           --- number found

               iseq = nint(realrd)
               if ( iretur.eq.2 ) then
                  ih = maxtrans
               else
                  ih = maxturb
               end if
               if ( iseq.lt.1 .or. iseq.gt.ih ) then

c              --- iseq out of range

                  call iserrchr ( codema(iretur), 1 )
                  call iserrint ( iseq, 1 )
                  call iserrint ( 1, 2 )
                  call iserrint ( ih, 3 )
                  call iserrsub ( 530, 3, 0, 1 )
                  call iserrcrd
                  iseq = 1

               end if

            else if ( ityprd.eq.4 .and. string(1:3).eq.'ALL' ) then

c           --- text all found set iseq equal to -iretur

               iseq = -iretur

            else

c           --- Error not an integer number found

               call iserrchr ( codema(iretur), 1 )
               call iserrsub ( 528, 0, 0, 1 )
               call iserrcrd

            end if

         end if

         if ( numsub.eq.0 ) then

c        --- number_of_subkeywords = 0

            numsub = nncode

         else

c        --- interpret subkeywords as function of keyword_previous

            if ( keyprev.eq.1  ) then
               iequa = keyprev
            else if ( keyprev.eq.2 ) then
               if ( iseqprev.gt.0 ) then
                  iequa = iseqprev+1
               else
                  iequa = 2
               end if
            else
               if ( iseqprev.gt.0 ) then
                  iequa = iseqprev+maxtrans+1
               else
                  iequa = 2+maxtrans
               end if

            end if

c           --- Test if equation has already been treated before

            if ( icheckeq(iequa).ne.0 ) then
               call iserrint ( iseq, 1 )
               call iswarsub ( 567, 1, 0, 0 )
               call iserrcrd
            end if

c           --- Fill icheckeq

            do i = iequa, iequa+maxt-1
               icheckeq(i) = 1
            end do

            if ( table(25).gt.0 ) then

c           --- skip has been found

               do i = iequa, iequa+maxt-1
                  iindsc(1,i) = 0
                  iseqeq(i+lshift) = 0
               end do
               if ( iequa.eq.1 ) iseqeq(2) = 0
               if ( table(2).gt.0 ) then

c              --- Error: also noskip has been found

                  call iserrchr ( code(keyprev), 1 )
                  call iserrsub ( 532, 0, 0, 1 )

               end if

            end if

            if ( table(1).gt.0 ) then

c           --- skip_continuity_equation has been found

               if ( iequa.ne.1 ) then

c              --- Error: skip_continuity_equation only allowed for
c                         momentum equations

                  call iserrsub ( 629, 0, 0, 0 )

               end if
               iindsc(1,2) = 0
               iseqeq(2)   = 0
               if ( table(2).gt.0 ) then

c              --- Error: also noskip has been found

                  call iserrsub ( 628, 0, 0, 0 )

               end if

            end if

            if ( table(4).gt.0 ) then

c           --- noconvection has been found

               do i = iequa, iequa+maxt-1
                  iindsc(1,i) = 2
               end do
               if ( table(3).gt.0 ) then

c              --- Error: also convection has been found

                  call iserrchr ( code(keyprev), 1 )
                  call iserrsub ( 533, 0, 0, 1 )

               end if

            end if

            if ( table(5).gt.0 ) then
               ih = nint(table(5))
               do i = 1, maxtrans+1+maxturb
                  iindsc(2,i) =  ih
               end do
            end if
            if ( table(6).gt.0 ) then
               ih = nint(table(6))
               do i = iequa, iequa+maxt-1
                  iindsc(4,i) =  ih
               end do
            end if
            if ( table(8).gt.0 ) then
               ih = nint(table(8))-1
               do i = iequa, iequa+maxt-1
                  iindsc(6,i) =  ih
               end do
            end if
            if ( table(14).gt.0 ) then
               ih = nint(table(14))
               do i = iequa, iequa+maxt-1
                  iindsc(8,i) =  ih
               end do
            end if

c           --- Print MATRIX

            if ( iequa.eq.1 .and. table(15).gt.0 .or. table(16).gt.0
     +          .or. table(17).gt.0 ) then
               ih = nint(table(15))+2*nint(table(16))+4*nint(table(17))
               iindsc(11,1) =  ih
            else if ( table(15).gt.0 ) then
               ih = nint(table(15))
               do i = iequa, iequa+maxt-1
                  iindsc(11,i) =  ih
               end do
            end if

c           --- Print VECTOR

            if ( iequa.eq.1 .and. table(18).gt.0 .or. table(19).gt.0 )
     +         then
               ih = nint(table(18))+2*nint(table(19))
               iindsc(12,1) =  ih
            else if ( table(18).gt.0 ) then
               ih = nint(table(18))
               do i = iequa, iequa+maxt-1
                  iindsc(12,i) =  ih
               end do
            end if

c           --- PRINT_STEPS found

            if ( table(20).gt.0 ) then

c           --- PRINT_STEPS found

               ih = nint(table(20))
               inum = nint(tabmax(20))
               do i = iequa, iequa+maxt-1
                  iindsc(13,i) = nint(tabout(ih))
                  if ( inum.gt.1 ) then
                     iindsc(14,i) = nint(tabout(ih+1))
                  else
                     iindsc(14,i) = iindsc(13,i)
                  end if
                  if ( inum.gt.2 ) then
                     iindsc(15,i) = nint(tabout(ih+2))
                  else
                     iindsc(15,i) = 1
                  end if
               end do
            end if
            if ( table(7).gt.0 ) then

c           --- UPWIND found

               ih = nint(table(7))-1
               if ( ih.eq.3 ) then

c              --- HIGHER_ORDER found, set rindsc(1)

                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = table(13)
                  end do

               else if ( ih.eq.4 ) then

c              --- TVD found, set rindsc(1-4)

                  limiter = nint(table(9))
                  ih = ih + limiter - 1
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = table(13)
                     rindsc(2,i) = table(11)
                     rindsc(3,i) = table(12)
                     rindsc(4,i) = -table(13)
                  end do

               else if ( ih.eq.5 ) then

c              --- LUDS found, set rindsc(1)

                  ih = 3
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = -1d0
                  end do

               else if ( ih.eq.6 ) then

c              --- QUICK found, set rindsc(1)

                  ih = 3
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 5d-1
                  end do

               else if ( ih.eq.7 ) then

c              --- CUI found, set rindsc(1)

                  ih = 3
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 1d0/3d0
                  end do

               else if ( ih.eq.8 ) then

c              --- FROMM found, set rindsc(1)

                  ih = 3
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 0d0
                  end do

               else if ( ih.eq.9 ) then

c              --- MINMOD found, set rindsc(2)

                  ih = 4
                  do i = iequa, iequa+maxt-1
                     rindsc(2,i) = 1d0
                  end do

               else if ( ih.eq.10 ) then

c              --- SUPERBEE found, set rindsc(2)

                  ih = 4
                  do i = iequa, iequa+maxt-1
                     rindsc(2,i) = 2d0
                  end do

               else if ( ih.eq.11 ) then

c              --- VAN_LEER found, set rindsc(1)

                  ih = 5
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 0d0
                  end do

               else if ( ih.eq.12 ) then

c              --- ISNAS found, set rindsc(1)

                  ih = 5
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 5d-1
                  end do

               else if ( ih.eq.13 ) then

c              --- KOREN found, set rindsc(1), rindsc(3), rindsc(4)

                  ih = 8
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 1d0/3d0
                     rindsc(3,i) = 2d0
                     rindsc(4,i) = 0d0
                  end do

               else if ( ih.eq.14 ) then

c              --- SMART found, set rindsc(1), rindsc(3), rindsc(4)

                  ih = 8
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 5d-1
                     rindsc(3,i) = 4d0
                     rindsc(4,i) = 0d0
                  end do

               else if ( ih.eq.15 ) then

c              --- UMIST found, set rindsc(1), rindsc(3)

                  ih = 11
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 5d-1
                     rindsc(3,i) = 2d0
                  end do

               else if ( ih.eq.16 ) then

c              --- MUSCL found, set rindsc(1), rindsc(3), rindsc(4)

                  ih = 8
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 0d0
                     rindsc(3,i) = 2d0
                     rindsc(4,i) = 0d0
                  end do

               else if ( ih.eq.17 ) then

c              --- DAVIS found, set rindsc(1), rindsc(3), rindsc(4)

                  ih = 8
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = -1d0
                     rindsc(3,i) =  1d0
                     rindsc(4,i) =  0d0
                  end do

               else if ( ih.eq.18 ) then

c              --- HLPA found, set rindsc(1)

                  ih = 5
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 0d0
                  end do

               else if ( ih.eq.19 ) then

c              --- SOUCUP found, set rindsc(2)

                  ih = 4
                  do i = iequa, iequa+maxt-1
                     rindsc(2,i) = 1d0
                  end do

               else if ( ih.eq.20 ) then

c              --- BSOU found, set rindsc(1), rindsc(3), rindsc(4)

                  ih = 8
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = -1d0
                     rindsc(3,i) =  1d0
                     rindsc(4,i) =  0d0
                  end do

               else if ( ih.eq.21 ) then

c              --- NOTABLE found, set rindsc(1)

                  ih = 5
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 5d-1
                  end do

               else if ( ih.eq.22 ) then

c              --- HARMONIC found, set rindsc(1)

                  ih = 5
                  do i = iequa, iequa+maxt-1
                     rindsc(1,i) = 0d0
                  end do

               else if ( ih.eq.23 ) then

c              --- VAN_ALBADA found, set rindsc(3)

                  ih = 7
                  do i = iequa, iequa+maxt-1
                     rindsc(3,i) = 1d0
                  end do

               else if ( ih.eq.24 ) then

c              --- OSPRE found, set rindsc(3)

                  ih = 7
                  do i = iequa, iequa+maxt-1
                     rindsc(3,i) = 1.5d0
                  end do

               end if

               do i = iequa, iequa+maxt-1
                  iindsc(5,i) =  ih
               end do

c              --- Warning: combination of UPWIND and NEWTON have been found

               if ( iindsc(8,1).ne.2 .and. iindsc(5,1).ne.0 ) then
                 call iswarsub ( 606, 0, 0, 0 )
               end if

            end if

c           --- Keywords coupled and decoupled

            if ( table(21).gt.0 ) then
               do i = iequa, iequa+maxt-1
                  iindsc(7,i) =  1
               end do
            else if ( table(22).gt.0 ) then
               do i = iequa, iequa+maxt-1
                  iindsc(7,i) =  0
               end do
            end if
            if ( table(21).gt.0 .and. table(22).gt.0 ) then

c           --- The keywords COUPLED and DECOUPLED are mutually exclusive

               call iserrchr ( code(1), 1 )
               call iserrchr ( code(2), 2 )
               call iserrsub ( 587, 0, 0, 2 )

            end if

c           --- Keyword conservative

            if ( table(23).gt.0 ) then
               do i = iequa, iequa+maxt-1
                  iindsc(9,i) =  1
               end do
           end if

c          --- Keyword axisymmetric

            if ( table(24).gt.0 ) then

               if ( iindsc(2,1) .ne.2 ) then
                  call iserrchr ( code(24), 1 )
                  call iserrchr ( code2(2), 2 )
                  call iserrsub ( 718, 0, 0, 2 )
               end if

               do i = 1, maxtrans+1+maxturb
                  iindsc(10,i) =  1
               end do
           end if

         end if

         if ( iretur.gt.newmain ) then

c        --- main keyword found

            ready = .true.
            iretur = iretur-newmain

         else if ( iretur.le.-1 ) then

c        --- end of file found

            ready = .true.

         end if
         if ( iseq.eq.-2 ) then
            maxt = maxtrans
            lshift = 1
         else if ( iseq.eq.-3 ) then
            maxt = maxturb
            lshift = 1
         else
            maxt = 1
            lshift = 0
         end if
         keyprev = iretur
         iseqprev = iseq
         go to 200

      end if

      call iserclos ( 'isrddisc' )
      end
