      subroutine iserrcrd
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Subroutine extracted from the SEPRAN
c                                        subroutine ERRCRD version 1.1)
c
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c   Print the last record read and underline the columns between
c   kcolum and icolum
c   This subroutine is meant to indicate the positions that are incorrect
c   during input. So it is an extra subroutine providing error messages
c   This subroutine replaces the old subroutine ercard
c ********************************************************************
c
c                      KEYWORDS
c
c   error_manipulation
c   read_cards
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
c
c ********************************************************************
c
c                COMMON BLOCKS
c
      include 'IScommon/csepch'
      include 'IScommon/cseprd'
      include 'IScommon/cisnas'
c ********************************************************************
c
c                LOCAL PARAMETERS
c

      integer i, ifircol, ilascol
      character * 80 text

c    i       General loop variable
c    ifircol First recomputed column number that must be underlined
c    ilascol Last recomputed column number that must be underlined
c    text    String in which a text is stored
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c ********************************************************************
c
c                    I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c   -
c ********************************************************************
c
c                    PSEUDO CODE
c
c     Print first part of error message
c     Compute column numbers for the printing
c     Print *** under the computed column numbers
c ======================================================================
c
c     --- Print first part of error message

      write(irefwr,110) cardim(1:min(79,lastp))
110   format(//' Last record read:  ( The underlined positions could ',
     +         'not be interpreted)'//1x,a)

c     --- Compute Column numbers for the printing

      ifircol = min ( 79, kcolum-80+last)
      if ( icolum.eq.0 ) then
         ilascol = min (79,last)
      else
         ilascol = min (79, icolum-80+last, last )
      end if
      text = ' '
      do 120 i = ifircol, ilascol
         text(i:i) = '*'
120   continue
      write(irefwr,130) text(1:ilascol)
130   format(1x,a//)
      end
