      subroutine isinitcb
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.3    date   23-07-1998 Jason: remove init cisparal
c        version 1.2    date   30-01-1996 Initialize info
c        version 1.1    date   17-02-1995 Remove cdebug
c        version 1.0    date   08-02-1994
c
c
c   copyright (c) 1994-1996  "Delft University of Technology"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Delft University of Technology".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     ad-hoc subroutine to initialize all ISNaS commons in the test phase
c
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisglob'
      include 'IScommon/cisnas'
      include 'IScommon/cismessg'
      include 'IScommon/cismessc'
      include 'IScommon/cfile3'
      include 'IScommon/erik01'
      include 'IScommon/ciscom'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, j, vofeq(26)

c    i        General loop variable
c    j        General loop variable
c    vofeq    Array for storing the matrix off-sets which are then
c             copied to vof, vof1 and vof2 respectively.
c             This array is needed because the initialization of
c             the common 'erik01' was done by a program which converts
c             data statements to componentwise (1-dimensional) array
c             initializations.
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- common cisglob

      do i=1, maxblocki
         indorien(i)=1
      end do

c     --- common cfile3

      ifree3 = 1
      irec3 = 0
      iref3 = 3

c     --- cisnas

      icarcn = 0
      ierror = 0
      nerror = 0
      maxerr = 10
      iwarn  = 0
      nwarn  = 0
      maxwar = 100
      do 100 i = 1, 94
         ierrors(i) = 0
100   continue
      ioutpt = 1
      itime  = 0
      iblockrf = 0
      iterat = 0
      do 110 i = 1, 95
         ioutps(i) = 0
110   continue
      t      = 0d0
      ileft  = 1
      iright = 2
      idown  = 3
      iup    = 4
      ip00   = 2
      ip10   = 3
      ip20   = 4
      ip01   = 5
      ip11   = 1
      ip21   = 6
      ip02   = 7
      ip12   = 8
      ip22   = 9
      do 120 i = 1, 87
         iconst(i) = 0
120   continue

c     --- cismessc and cismessg

      do 140 i = 1, 1000
         chars(i) = ' '
140   continue
      do 150 i = 1, 1000
         reals(i) = 0d0
         ints(i)  = 0
150   continue
      levelsub = 0


c        --- INITIALIZATION OF TEMPORARY COMMON BLOCKS STARTS HERE  ---
c            ---------------------------------------------------------------

c            --- common erik01 (used for storing stencil positions of virtual
c            coefficients in the momentum and pressure matrices and
c            a matrix-offset table)
c            THIS IS A TEMPORARY COMMON-BLOCK

c            --- initialize vleft

      vleft(1) = 2
      vleft(2) = 5
      vleft(3) = 7

c     --- initialize vright

      vright(1) = 4
      vright(2) = 6
      vright(3) = 9

c     --- initialize vup

      vup(1) = 7
      vup(2) = 8
      vup(3) = 9

c     --- initialize vdown

      vdown(1) = 2
      vdown(2) = 3
      vdown(3) = 4

c     --- initialize vbl

      vbl(1) = 2
      vbl(2) = 5
      vbl(3) = 7
      vbl(4) = 3
      vbl(5) = 4

c     --- initialize vbr

      vbr(1) = 2
      vbr(2) = 3
      vbr(3) = 4
      vbr(4) = 6
      vbr(5) = 9

c     --- initialize vtl

      vtl(1) = 2
      vtl(2) = 5
      vtl(3) = 7
      vtl(4) = 8
      vtl(5) = 9

c     --- initialize vtr

      vtr(1) = 7
      vtr(2) = 8
      vtr(3) = 9
      vtr(4) = 6
      vtr(5) = 4

c     --- initialize vleft1

      vleft1(1) = 2
      vleft1(2) = 5
      vleft1(3) = 7
      vleft1(4) = 10
      vleft1(5) = 12

c     --- initialize vright1

      vright1(1) = 4
      vright1(2) = 6
      vright1(3) = 9
      vright1(4) = 11
      vright1(5) = 13

c     --- initialize vdown1

      vdown1(1) = 2
      vdown1(2) = 3
      vdown1(3) = 4

c     --- initialize vup1

      vup1(1) = 7
      vup1(2) = 8
      vup1(3) = 9

c     --- initialize vbl1

      vbl1(1) = 2
      vbl1(2) = 5
      vbl1(3) = 7
      vbl1(4) = 10
      vbl1(5) = 12
      vbl1(6) = 3
      vbl1(7) = 4

c     --- initialize vbr1

      vbr1(1) = 2
      vbr1(2) = 3
      vbr1(3) = 4
      vbr1(4) = 6
      vbr1(5) = 9
      vbr1(6) = 11
      vbr1(7) = 13

c     --- initialize vtl1

      vtl1(1) = 2
      vtl1(2) = 5
      vtl1(3) = 7
      vtl1(4) = 10
      vtl1(5) = 12
      vtl1(6) = 8
      vtl1(7) = 9

c     --- initialize vtr1

      vtr1(1) = 7
      vtr1(2) = 8
      vtr1(3) = 9
      vtr1(4) = 4
      vtr1(5) = 6
      vtr1(6) = 11
      vtr1(7) = 13

c     --- initialize vleft2

      vleft2(1) = 2
      vleft2(2) = 5
      vleft2(3) = 7

c     --- initialize vright2

      vright2(1) = 4
      vright2(2) = 6
      vright2(3) = 9

c     --- initialize vdown2

      vdown2(1) = 2
      vdown2(2) = 3
      vdown2(3) = 4
      vdown2(4) = 10
      vdown2(5) = 11

c     --- initialize vup2

      vup2(1) = 12
      vup2(2) = 13
      vup2(3) = 7
      vup2(4) = 8
      vup2(5) = 9

c     --- initialize vbl2

      vbl2(1) = 2
      vbl2(2) = 5
      vbl2(3) = 7
      vbl2(4) = 10
      vbl2(5) = 11
      vbl2(6) = 3
      vbl2(7) = 4

c     --- initialize vbr2

      vbr2(1) = 10
      vbr2(2) = 11
      vbr2(3) = 2
      vbr2(4) = 3
      vbr2(5) = 4
      vbr2(6) = 6
      vbr2(7) = 9

c     --- initialize vtl2

      vtl2(1) = 2
      vtl2(2) = 5
      vtl2(3) = 7
      vtl2(4) = 8
      vtl2(5) = 9
      vtl2(6) = 12
      vtl2(7) = 13

c     --- initialize vtr2

      vtr2(1) = 12
      vtr2(2) = 13
      vtr2(3) = 7
      vtr2(4) = 8
      vtr2(5) = 9
      vtr2(6) = 4
      vtr2(7) = 6

c     --- initialize iunk1

      iunk1(1) = 1
      iunk1(2) = 1
      iunk1(3) = 1
      iunk1(4) = 1
      iunk1(5) = 1
      iunk1(6) = 1
      iunk1(7) = 1
      iunk1(8) = 1
      iunk1(9) = 1
      iunk1(10) = 2
      iunk1(11) = 2
      iunk1(12) = 2
      iunk1(13) = 2

c     --- initialize iunk2

      iunk2(1) = 2
      iunk2(2) = 2
      iunk2(3) = 2
      iunk2(4) = 2
      iunk2(5) = 2
      iunk2(6) = 2
      iunk2(7) = 2
      iunk2(8) = 2
      iunk2(9) = 2
      iunk2(10) = 1
      iunk2(11) = 1
      iunk2(12) = 1
      iunk2(13) = 1

c     --- initialize vof

      vofeq(1) = 0
      vofeq(2) = 0
      vofeq(3) = -1
      vofeq(4) = -1
      vofeq(5) = 0
      vofeq(6) = -1
      vofeq(7) = 1
      vofeq(8) = -1
      vofeq(9) = -1
      vofeq(10) = 0
      vofeq(11) = 1
      vofeq(12) = 0
      vofeq(13) = -1
      vofeq(14) = 1
      vofeq(15) = 0
      vofeq(16) = 1
      vofeq(17) = 1
      vofeq(18) = 1

      do i = 1, 9
         do j = 1, 2
            vof(i,j) = vofeq(j + (i-1)*2)
         end do
      end do

c     --- initialize vof1

      vofeq(1) = 0
      vofeq(2) = 0
      vofeq(3) = -1
      vofeq(4) = -1
      vofeq(5) = 0
      vofeq(6) = -1
      vofeq(7) = 1
      vofeq(8) = -1
      vofeq(9) = -1
      vofeq(10) = 0
      vofeq(11) = 1
      vofeq(12) = 0
      vofeq(13) = -1
      vofeq(14) = 1
      vofeq(15) = 0
      vofeq(16) = 1
      vofeq(17) = 1
      vofeq(18) = 1
      vofeq(19) = -1
      vofeq(20) = 0
      vofeq(21) = 0
      vofeq(22) = 0
      vofeq(23) = -1
      vofeq(24) = 1
      vofeq(25) = 0
      vofeq(26) = 1

      do i = 1, 13
         do j = 1, 2
           vof1(i,j) = vofeq(j+(i-1)*2)
         end do
      end do

c     --- initialize vof2

      vofeq(1) = 0
      vofeq(2) = 0
      vofeq(3) = -1
      vofeq(4) = -1
      vofeq(5) = 0
      vofeq(6) = -1
      vofeq(7) = 1
      vofeq(8) = -1
      vofeq(9) = -1
      vofeq(10) = 0
      vofeq(11) = 1
      vofeq(12) = 0
      vofeq(13) = -1
      vofeq(14) = 1
      vofeq(15) = 0
      vofeq(16) = 1
      vofeq(17) = 1
      vofeq(18) = 1
      vofeq(19) = 0
      vofeq(20) = -1
      vofeq(21) = 1
      vofeq(22) = -1
      vofeq(23) = 0
      vofeq(24) = 0
      vofeq(25) = 1
      vofeq(26) = 0

      do i = 1, 13
         do j = 1, 2
            vof2(i,j) = vofeq(j + (i-1)*2)
         end do
      end do

c     --- initialize ciscom

      do i = 1, 10
         info(i) = 0
      end do
      end
