      subroutine issetpri ( index, iprio, ibuffr )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c ********************************************************************
c
c                         DESCRIPTION
c
c     set priority of one array stored in IBUFFR explicitly.
c     This is especially meant to give an array priority number 100
c ********************************************************************
c
c                      KEYWORDS
c
c     memory_management
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer index, iprio, ibuffr(*)

c     ibuffr  i    reserved
c     index   i    Integer variable containing the sequence number of the
c                  array to be processed
c     iprio   i    Priority number
c ********************************************************************
c
c                      COMMON BLOCKS
c
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer iinfor

c     iinfor  Number of arrays that has been referenced
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRINT  Put integer value in error message file
c     ISERRSUB  Error messages
c     ISSTOP    Stop ISNAS
c ********************************************************************
c
c                    I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c    1400   INDEX out of range
c ********************************************************************
c
c                    PSEUDO CODE
c
c     trivial
c ======================================================================
c
      iinfor = ibuffr(3)
      if ( index.le.0 .or. index.gt.iinfor ) then

c     --- index < 0: error

         call iseropen ( 'issetpri' )
         call iserrint ( index,  1 )
         call iserrint ( index, 2 )
         call iserrint ( iinfor+1, 3 )
         call iserrsub ( 1400, 3, 0, 0 )
         call isstop

      else

         ibuffr(13+3*(index-1)) = iprio

      end if
      call iserclos('issetpri')
      end
