      subroutine iswarsub ( mesnmseq, nints, nreal, nchar )
c ====================================================================
c
c        Programmer     Guus Segal
c        
c        version 1.1    date 23-11-1998 Jason: added call to isersend
c        version 1.0    date   21-06-94 (Extracted from the SEPRAN subroutine
c                                        errwar version 2.3)
c
c
c     copyright (c) 1994  "Ingenieursbureau SEPRA"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "Ingenieursbureau SEPRA"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c     ISWARSUB prints a warning message.
c
c ********************************************************************
c
c                      KEYWORDS
c
c     memory_management
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer mesnmseq, nints, nreal, nchar

c     mesnmseq i    Message sequence number.
c     nchar    i    Number of strings in a message
c     nints    i    Number of integers in a message
c     nreal    i    Number of reals in a message
c ********************************************************************
c
c                     COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cismessg'
      include 'IScommon/cismessc'
      include 'IScommon/ciscom'
      include 'IScommon/cisparal'
c ********************************************************************
c
c                         LOCAL PARAMETERS
c
c     None.
c ********************************************************************
c
c                            I / O
c
c     ISWARSUB writes to the default output device if it is called at the host
c     If ISWARSUB is called at the node information is sent to the host
c ********************************************************************
c
c                         SUBROUTINES CALLED
c
c     ISERMESS  Prints a message, stored in the Error Text File.
c     ISERSEND  Send error data to node or host
c ********************************************************************
c
c                         ERROR MESSAGES
c
c     Number of warnings = maxwar , subsequent warnings suppressed.
c ********************************************************************
c
c                         PSEUDO CODE
c
c     If ( mesnum<0 or nodenr=0 ) then
c        Increment NWARN (number of warnings);
c        If (number of warnings <= maxwar) then
c           Call ISERMESS;
c           If (number of warnings = maxwar) then
c              Print message;
c     else ( nodenr>0 )
c        Put information of warning in array info
c        send information of warning by issend to host
c ====================================================================
c
      if ( mesnmseq.lt.0 .or. inodenr.eq.ISHOST ) then

c     --- Program runs at host

         nwarn = nwarn + 1

         if ( nwarn.le.maxwar ) then

c        --- Print the message, stored in the Error Text File.

            call isermess ( abs(mesnmseq), nints, nreal, nchar,
     +                      'WARNING' )

            iwarn = abs(mesnmseq)

c           --- Print a warning if the number of warnings = maxwar.

            if ( nwarn.ge.maxwar ) then
               write (irefwr,'(//1x,78(''*'')/)')
               write (irefwr,1500) maxwar
               write (irefwr,'(/1x,78(''*'')//)')
            end if

         end if

 1500    format (' WARNING : Number of warnings = ', i4,'; '/
     +           ' Subsequent warnings will be suppressed ')

      else

c     --- Program runs at node
c     --- send information of error to host

         call isersend ( mesnmseq, nints, nreal, nchar, ICWARN )

      end if

      end
