      subroutine isdiagmu ( nvecy, vecy, diag )
c ======================================================================
c
c
c        programmer     Kees Vuik
c        version 2.0    date 08-02-95 Guus: Removal of superfluous parameters
c        version 1.0    date 03-11-94 extracted from old ISNaS
c                                     subroutine diagmu
c
c
c   copyright (c) 1994-1995  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                      DESCRIPTION
c
c     Multiplication of vecy by the diagonal matrix given in diag.
c     The result is stored in vecy
c ********************************************************************
c
c                      KEYWORDS
c
c
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer          nvecy
      double precision diag(nvecy), vecy(nvecy)

c     diag      i    Diagonal matrix stored as vector
c     nvecy     i    Length of array vecy
c     vecy     i/o   Vector to be updated
c ********************************************************************
c
c                      COMMON BLOCKS
c
c ********************************************************************
c
c                      LOCAL PARAMETERS

      integer          i

c     i         General loop variable
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c     Multiplication of vecy by the diagonal matrix given in diag.
c     The result is given in vecy.
c ======================================================================
c
      do i = 1, nvecy
         vecy(i) = vecy(i)*diag(i)
      end do
      end

