      subroutine dcopy(n, dx, incx, dy, incy)
c
c        version 1.1    date   22-08-91 (Zdenek: no dimension, cdc, ce)
c
c     copy double precision dx to double precision dy.
c     for i = 0 to n-1, copy dx(lx+i*incx) to dy(ly+i*incy),
c     where lx = 1 if incx .ge. 0, else lx = (-incx)*n, and ly is
c     defined in a similar way using incy.
c
      implicit double precision (a-h,o-z)
      double precision dx(*), dy(*)
      if (n.le.0) return
      if (incx.eq.incy) if (incx-1) 10, 30, 70
   10 continue
c
c        code for unequal or nonpositive increments.
c
      ix = 1
      iy = 1
      if (incx.lt.0) ix = (-n+1)*incx + 1
      if (incy.lt.0) iy = (-n+1)*incy + 1
      do 20 i=1,n
         dy(iy) = dx(ix)
         ix = ix + incx
         iy = iy + incy
   20 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop so remaining vector length is a multiple of 7.
c
   30 m = mod(n,7)
      if (m.eq.0) go to 50
      do 40 i=1,m
         dy(i) = dx(i)
   40 continue
      if (n.lt.7) return
   50 mp1 = m + 1
      do 60 i=mp1,n,7
         dy(i) = dx(i)
         dy(i+1) = dx(i+1)
         dy(i+2) = dx(i+2)
         dy(i+3) = dx(i+3)
         dy(i+4) = dx(i+4)
         dy(i+5) = dx(i+5)
         dy(i+6) = dx(i+6)
   60 continue
      return
c
c        code for equal, positive, nonunit increments.
c
   70 continue
      ns = n*incx
      do 80 i=1,ns,incx
         dy(i) = dx(i)
   80 continue
      return
      end
