      subroutine uspcompphiint(T,pphiint)
c ======================================================================
c
c        programmer     Philipe Reynier
c        version 1.0    date 06-07-1999
c
c
c   copyright (c) 1999-1999  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Sample user subroutine to calculate the integral of phi
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      double precision pphiint, T, a, b, c, rk2, R, rn

c                         For a description see the programmers guide
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      double precision ak(7), Tc

c     ak array of the series coefficients
c     Tc temperature at the critical point

      integer k

c     k              General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c         usccoefhydr
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
      call uscoefhydr(a,b,c,rk2,R,rn)

      ak(1) = 3.308373371068d0
      ak(2) = 9.577904496647d0
      ak(3) = -42.7878181830733d0
      ak(4) = 143.5204743454d0
      ak(5) = -208.024055939d0
      ak(6) = 139.5022086855d0
      ak(7) = -35.8884206558d0

      Tc = 653.15d0

c     --- calculation of phiint
c         T is the temperature

      pphiint = - T
      do k=1,7
         pphiint = pphiint + Tc*(ak(k)/k)*((T/Tc)**k)
      end do
      pphiint = R*pphiint
      end
