      subroutine isgettim ( timerl )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.1    date   02-03-1999 Gary: adapted for Fujitsu VPP700
c        version 1.0    date   23-04-1996 Renamed subroutine isaskclk
c
c
c
c   copyright (c) 1996-1999  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c      the actual time since the preceding call of isiniclk is put into
c      the parameter time
c      This subroutine is machine dependent
c **********************************************************************
c
c                       KEYWORDS
c
c     time
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      real timerl

c     timerl    Time in seconds since the last call of isiniclk
c **********************************************************************
c
c                       COMMON BLOCKS
c
      common /cdctim/ tim1
      save /cdctim/
      real tim1

c                 /cdctim/
c     Keep the initial time
c     tim1    i   Time at call of iniclk
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      real dum

cray      real second
cvpp      real second
cybr      real second
c     dum       Dummy parameter not used
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
      integer isasktim

c     ISASKTIM  Actual time subroutine written in c
c **********************************************************************
c
c                       I/O
c
c    none
c **********************************************************************
c
c                       ERROR MESSAGES
c
c   -
c **********************************************************************
c
c                       PSEUDO CODE
c
c   trivial
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- General time subroutine in various versions available
c         For some computers local

cuni      dum = isasktim(timerl)

c     --- Convex

ccon       timerl = cputime(0.)

c     --- VAX

cvax      timerl = secnds(tim1)

c     --- Cyber

cybr      timerl = second() - tim1

c     --- Cray

cray      timerl = second() - tim1

c     --- Fujitsu VPP700

cvpp      timerl = second() - tim1

c     --- IBM PC with the 80386 processor and FTN77/386 compiler

cipc      call clock@ (timerl)
cipc      timerl = timerl - tim1

      end
